import pandas as pd
import numpy as np
import matplotlib.pyplot as plt
import japanize_matplotlib
import scipy.stats as ss

finnm = input('入力データファイル（*.xlsx）= ')
txtoutnm = input('出力ファイル（*.txt）= ')
txtout = open(txtoutnm, 'w')
foutnm = input('画像保存ファイル（*.png）= ')
#
#      Excelファイルの読み込み
#　　　モジュール xlrd がインストール済みであること
#
xlsx_fl = pd.ExcelFile(finnm)                       #   ExcelファイルからExcelFile型オブジェクトを生成
data_xlsx = pd.read_excel(xlsx_fl,  header = None)  #   ExcelFile型オブジェクトからDataFrame型オブジェクトを生成
data = data_xlsx.values                             #   Dataframe型オブジェクトからnumpyの配列オブジェクトを生成
print('\n', data)

txtout.write('\n入力データファイル: {}\n'.format(finnm))

VarNameA = data[0][1]
VarNameB = data[0][2]

dataA = []
dataB = []
for i in range(1,len(data)):
    if not pd.isnull(data[i][1]):
        dataA.append(data[i][1])
    if not pd.isnull(data[i][2]):
        dataB.append(data[i][2])
print('dataA =\n', dataA)
print('dataB =\n', dataB)

txtout.write('\n{0}\n'.format(VarNameA))
txtout.write('{0}\n'.format(dataA))
txtout.write('\n{0}\n'.format(VarNameB))
txtout.write('{0}\n'.format(dataB))

results = ss.ttest_ind(dataA, dataB)                       #   Student
vL, vU = results.confidence_interval(0.95)
print(f"\nt値 = {results.statistic:.5f}   df = {results.df}" + \
      f"   p値（両側） = {results.pvalue:.5f}" +
      f"   95%CI = [{vL:.3f}, {vU:.3f}]")
txtout.write(f"\n\nt値 = {results.statistic:.5f}   df = {results.df}" + \
      f"   p値（両側） = {results.pvalue:.5f}" +
      f"   95%CI = [{vL:.3f}, {vU:.3f}]\n")

resultsw = ss.ttest_ind(dataA,dataB, equal_var = False)    #   Welch
vLw, vUw = resultsw.confidence_interval(0.95)
print('\nWelch')
print(f"t'値 = {resultsw.statistic:.5f}   df' = {resultsw.df:.2f}" + \
      f"   p'値（両側） = {resultsw.pvalue:.5f}" +
      f"   95%CI = [{vLw:.3f}, {vUw:.3f}]\n")
txtout.write('\nWelch:\n')
txtout.write(f"t'値 = {resultsw.statistic:.5f}   df' = {resultsw.df:.2f}" + \
      f"   p'値（両側） = {resultsw.pvalue:.5f}" +
      f"   95%CI = [{vLw:.3f}, {vUw:.3f}]\n")

meanA = np.mean(dataA)
meanB = np.mean(dataB)
sdA = np.std(dataA)
sdB = np.std(dataB)
print(VarNameA)
print('平均値 = {0:.2f}　　標準偏差 = {1:.2f}'.format(meanA, sdA))
print(VarNameB)
print('平均値 = {0:.2f}　　標準偏差 = {1:.2f}'.format(meanB, sdB))
txtout.write('\n' + VarNameA + '\n')
txtout.write('平均値 = {0:.2f}　　標準偏差 = {1:.2f}\n'.format(meanA, sdA))
txtout.write('\n' + VarNameB + '\n')
txtout.write('平均値 = {0:.2f}　　標準偏差 = {1:.2f}\n'.format(meanB, sdB))

#       日本語表記の設定
#plt.rcParams['font.family'] = ['Yu Gothic', 'Noto Sans CJK JP', 'Hiragino Maru Gothic Pro']

plt.title(('{0}： mean = {1:.2f}  sd = {2:.2f}'.format(VarNameA, meanA, sdA)) + \
          '\n{0}： mean = {1:.2f}  sd = {2:.2f}'.format(VarNameB, meanB, sdB),
          fontsize = 16)
plt.hist(dataA, alpha = 0.5, label = VarNameA)
plt.hist(dataB, alpha = 0.5, label = VarNameB)
plt.xlabel('値', fontsize = 14)
plt.ylabel('度数', fontsize = 14)
plt.legend()
plt.tight_layout()
plt.savefig(foutnm)
plt.show()

txtout.close()
print('\n出力ファイル{}が保存されました。\n'.format(txtoutnm))
print('画像ファイル{}が保存されました。\n'.format(foutnm))
